#!/usr/bin/python
# -*- coding=UTF-8 -*-

import sys, urllib, urllib2, time, re

class avance:
    def __init__(self, nomarch, largo):
        self.nomarch = nomarch
        self.total = 0
        self.antval = 0
        self.largo = largo
        if self.largo is None:
            print "Bajando '%s'" % self.nomarch
        else:
            print "Bajando '%s' [%s KB]..." % (self.nomarch, largo/1024)

    def step(self, cant):
        self.total += cant
        pt = self.total / 1024
        if pt == self.antval:
            return
        self.antval = pt
        sys.stdout.write("\r%7d KB" % pt)
        sys.stdout.flush()

    def done(self):
        if self.largo is None or self.largo == self.total:
            print "\rTerminado OK"
        else:
            print "Terminado con Error! Largo: %s   Total: %s" % (self.largo, self.total)
        return


def bajar_youtube(url, archout=None):
    # Estas constantes las saqu de este programa:
    # http://www.arrakis.es/~rggi3/youtube-dl/youtube-dl
    # Copyright (c) 2006-2008 Ricardo Garcia Gonzalez
    const_video_url_real_str = 'http://www.youtube.com/get_video?video_id=%s&t=%s'
    const_video_url_re = re.compile(r'^((?:http://)?(?:\w+\.)?youtube\.com/(?:v/|(?:watch(?:\.php)?)?\?(?:.+&)?v=))?([0-9A-Za-z_-]+)(?(1)[&/].*)?$')
    const_url_t_param_re = re.compile(r', "t": "([^"]+)"')

    print "Averiguando la URL real..."
    video_webpage = urllib.urlopen(url).read()

    # buscamos lo interesante
    video_url_mo = const_video_url_re.match(url)
    if video_url_mo is None:
        sys.exit('No encontramos el id del video')
    video_url_id = video_url_mo.group(2)
    print "id", video_url_id

    match = const_url_t_param_re.search(video_webpage)
    if match is None:
        sys.exit('No encontramos la url adentro de la pgina')

    video_url_t_param = match.group(1)
    video_url_real = const_video_url_real_str % (video_url_id, video_url_t_param)
    print "real", video_url_real

    u = urllib.urlopen(video_url_real)
    if u.headers["content-type"] not in ('video/flv', 'video/x-flv'):
        print "El tipo de contenido no es el correcto, sino:", u.headers["content-type"]
        print "Trajimos la info desde:", video_url_real
        sys.exit(1)
    largo = int(u.headers["content-length"])
    print u.headers.items()
    if archout is None:
        archout = "video_youtube_%s.flv" % int(time.time())
    print "--largo", largo
    bajaArch(u, archout, largo)
    return


def bajar_blip(url):
    print "Averiguando la URL real..."

    # bajamos el texto
    u = urllib.urlopen(url)
    t = u.read()

    # buscamos lo interesante
    print "Buscando OGV..."
    m = re.search("http://.*\.ogv", t)
    if not m:
        print "Buscando MP4..."
        m = re.search("http://.*\.mp4", t)
        if not m:
            print "Ningn formato til encontrado!"
            return
        else:
            print "  ok"
            formato_video = 'video/mp4'
    else:
        print "  ok"
        formato_video = 'video/ogg'

    url = m.group(0)
    print "Abriendo", repr(url)

    # abrimos el archivo remoto
    u = urllib.urlopen(url)
    if u.headers["content-type"] != formato_video:
        print "El tipo de contenido no es el correcto (%s), sino: %r" % (
                                formato_video, u.headers["content-type"])
        return

    largo = int(u.headers["content-length"])
    print "--largo", largo
    archout = url.split("/")[-1]
    bajaArch(u, archout, largo)
    return



def bajar_google(url):
    print "Averiguando la URL real..."

    # bajamos el texto
    u = urllib.urlopen(url)
    t = u.read()

    # buscamos lo interesante
    t = t[t.index("insertFlashHtmlOnLoad"):]
    t = t[t.index("http"):]
    t = t.split()[0]
    url = urllib2.unquote(t)
    #print url

    # abrimos el archivo remoto
    u = urllib.urlopen(url)
    if u.headers["content-type"] != 'video/x-flv':
        print "El tipo de contenido no es el correcto, sino: %s... reintentando." % u.headers["content-type"]
        # intentamos a ver si la url real est ms adelante (por ejemplo, video.google.de es as...)
        t = url[url.index("http", 1):]
        t = t.split()[0]
        url = urllib2.unquote(t)
        #print url

        # abrimos el archivo remoto... otra vez!
        u = urllib.urlopen(url)
        if u.headers["content-type"] != 'video/x-flv':
            print "El tipo de contenido no es el correcto, sino:", u.headers["content-type"]
            sys.exit(1)

    a = u.headers["content-disposition"]
    archout = a[a.index("filename=")+9:]
    bajaArch(u, archout)
    return



def buscaUrl(todo, ext, desdeatras=False):
    if desdeatras:
        t = todo[:todo.rindex(ext)+len(ext)]
    else:
        t = todo[:todo.index(ext)+len(ext)]
    return t[t.rindex("http"):]


def bajar_apple(url):
    print "Averiguando la URL real..."

    # limpiamos la url
    if "?" in url:
        t = url[:url.index("?")]
    else:
        t = url

    p = t.split("/")
    if not t.endswith(".mov") and len(p) == 7:
        # url base, de las nuevas
        del p[-1]
        u = urllib.urlopen(t)
        html = u.read()
        cola = "/".join(p[-1:])
        regexp = "http://.*?%s.*?\.mov" % cola
        all_movies = re.findall(regexp, html)

        print "Opciones:"
        for ind, url in enumerate(all_movies):
            print "   %2d. %s" % (ind, url)
        cual = raw_input("Ingrese cual: ")

        t = all_movies[int(cual)]
        p = t.split("/")

#    print "====== t", t
#    print "====== p", p

    trads = [
        ("-h.ref.mov", "_h480.mov"),
        ("_h.640.mov", "_h640w.mov"),
        ("_h640.mov", "_h.640.mov"),
        ("_h.i320.mov", "_h320.mov"),
        ("_h.i640.mov", "_h640w.mov"),
        ("_h.480.mov", "_h480.mov"),
        ("_h720p.mov", "_h720p.mov"),
        ("_720p.mov", "_h720p.mov"),
        ("_1080p.mov", "_h1080p.mov"),
        ("_h1080p.mov", "_h1080p.mov"),
        ("_h480.mov", "_h480.mov"),
        ("_480.mov", "_h480.mov"),
        ("_h480p.mov", "_h480p.mov"),
        ("_480p.mov", "_h480p.mov"),
    ]
    for orig, dest in trads:
        if t.endswith(orig):
            largo = len(orig)
            url = t[:-largo] + dest
            archout = p[-1][:-largo] + ".mov"
            break
    else:
        print "El formato de la URL es incorrecto:", t
        sys.exit(1)

    # abrimos el archivo remoto
    print "Abriendo", repr(url)
    u = urllib2.urlopen(urllib2.Request(url, headers={
                                            "User-Agent":"QuickTime/7.6.2"}))
    if u.headers["content-type"] != 'video/quicktime':
        print "El tipo de contenido no es el correcto, sino:", u.headers["content-type"]
        print "Trajimos la info desde:", url
        sys.exit(1)
    largo = int(u.headers["content-length"])
    bajaArch(u, archout)
    return


def bajaArch(u, archout, largo=None):
    # y lo bajamos
    av = avance(archout, largo)
    aout = open(archout, "wb")
    while True:
        r = u.read(4096*4)
        if r == "":
            break
        aout.write(r)
        av.step(len(r))
    av.done()
    return


# diccionario que decide qu funcin usar...
FUNC = {"www.youtube.com": bajar_youtube,
        "youtube.com":     bajar_youtube,
        "www.apple.com":   bajar_apple,
        "movies.apple.com":   bajar_apple,
        "trailers.apple.com":   bajar_apple,
        "video.google.com":   bajar_google,
        "video.google.de":   bajar_google,
        "pycon.blip.tv":   bajar_blip,
       }

if __name__ == "__main__":
    if len(sys.argv) < 2:
        print "Usar: bajavideo.py [--dest archivo_destino] url [url [...]]"
        print "      archivo_destino solo es usado con YouTube"
        sys.exit(1)

    if sys.argv[1] == '--dest':
        outfile = sys.argv[2]
        del sys.argv[1:3]
    else:
        outfile = None

    for url in sys.argv[1:]:
        partes = urllib2.urlparse.urlsplit(url)
        try:
            func = FUNC[partes[1]]
        except KeyError:
            print "No se reconoce a quien pertenece la url %r" % url
            continue

        if func == bajar_youtube:
            func(url, outfile)
        else:
            func(url)
        print
